/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 France Telecom R&D
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: SenderSingletonBean.java 21401 2011-06-08 21:37:00Z jppouzol $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.cxf.transport.reliablejms.example.ejbmdb.client.sender;

import java.net.URL;

import javax.annotation.PostConstruct;
import javax.ejb.Singleton;
import javax.ejb.Startup;

import org.apache.cxf.bus.spring.BusApplicationContext;
import org.apache.cxf.jms_greeter.JMSGreeterPortType;
import org.apache.cxf.jms_greeter.MyFault;
import org.ow2.jonas.cxf.transport.reliablejms.example.ejbmdb.client.MyService;
import org.springframework.context.ApplicationContext;

@Singleton
@Startup
public class SenderSingletonBean implements ISenderSingletonBean {

    public static final String SPRING_RESOURCE = "/cxf-mdb-client-sender.xml";

    public JMSGreeterPortType service = null;
    @PostConstruct
    public void init() {
        URL url = getClass().getResource(SPRING_RESOURCE);
        if (url == null) {
            throw new IllegalStateException("The resource '" + SPRING_RESOURCE
                    + "' has not been found by using classloader of the class '" + getClass() + "'.");
        }

        // init endpoint
        ApplicationContext context = new BusApplicationContext(url, true);

        service = (JMSGreeterPortType) ((MyService) context.getBean("WebService")).getService();

    }

    public void greetMe(String name) {
        try {
            service.greetMe(name);
        } catch (MyFault e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public void greetMeOneWay(String name) {
        service.greetMeOneWay(name);
    }

    public void sayHi(String name) {
        service.sayHi(name);
    }
}
